
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Purchase_ordersDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const purchase_orders = await db.purchase_orders.create(
            {
                id: data.id || undefined,
        
        po_number: data.po_number
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
        order_date: data.order_date
        ||
        null
            ,
            
        expected_delivery_at: data.expected_delivery_at
        ||
        null
            ,
            
        total_amount: data.total_amount
        ||
        null
            ,
            
        currency: data.currency
        ||
        null
            ,
            
        notes: data.notes
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await purchase_orders.setSupplier( data.supplier || null, {
            transaction,
        });
        
        await purchase_orders.setPlant( data.plant || null, {
            transaction,
        });
        

        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.purchase_orders.getTableName(),
                belongsToColumn: 'attachments',
                belongsToId: purchase_orders.id,
            },
            data.attachments,
            options,
        );
        

        return purchase_orders;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const purchase_ordersData = data.map((item, index) => ({
                id: item.id || undefined,
                
                po_number: item.po_number
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
                order_date: item.order_date
            ||
            null
            ,
            
                expected_delivery_at: item.expected_delivery_at
            ||
            null
            ,
            
                total_amount: item.total_amount
            ||
            null
            ,
            
                currency: item.currency
            ||
            null
            ,
            
                notes: item.notes
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const purchase_orders = await db.purchase_orders.bulkCreate(purchase_ordersData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < purchase_orders.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.purchase_orders.getTableName(),
                    belongsToColumn: 'attachments',
                    belongsToId: purchase_orders[i].id,
                },
                data[i].attachments,
                options,
            );
        }
        

        return purchase_orders;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const purchase_orders = await db.purchase_orders.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.po_number !== undefined) updatePayload.po_number = data.po_number;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.order_date !== undefined) updatePayload.order_date = data.order_date;
        
        
        if (data.expected_delivery_at !== undefined) updatePayload.expected_delivery_at = data.expected_delivery_at;
        
        
        if (data.total_amount !== undefined) updatePayload.total_amount = data.total_amount;
        
        
        if (data.currency !== undefined) updatePayload.currency = data.currency;
        
        
        if (data.notes !== undefined) updatePayload.notes = data.notes;
        
        
        updatePayload.updatedById = currentUser.id;

        await purchase_orders.update(updatePayload, {transaction});

        
        
        if (data.supplier !== undefined) {
            await purchase_orders.setSupplier(
              
              data.supplier,
              
              { transaction }
            );
        }
        
        if (data.plant !== undefined) {
            await purchase_orders.setPlant(
              
              data.plant,
              
              { transaction }
            );
        }
        

        
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.purchase_orders.getTableName(),
                belongsToColumn: 'attachments',
                belongsToId: purchase_orders.id,
            },
            data.attachments,
            options,
        );
        

        return purchase_orders;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const purchase_orders = await db.purchase_orders.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of purchase_orders) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of purchase_orders) {
                await record.destroy({transaction});
            }
        });


        return purchase_orders;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const purchase_orders = await db.purchase_orders.findByPk(id, options);

        await purchase_orders.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await purchase_orders.destroy({
            transaction
        });

        return purchase_orders;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const purchase_orders = await db.purchase_orders.findOne(
            { where },
            { transaction },
        );

        if (!purchase_orders) {
            return purchase_orders;
        }

        const output = purchase_orders.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.purchase_order_lines_purchase_order = await purchase_orders.getPurchase_order_lines_purchase_order({
            transaction
        });
        
        
        output.receipts_purchase_order = await purchase_orders.getReceipts_purchase_order({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.supplier = await purchase_orders.getSupplier({
            transaction
        });
        
        
        output.plant = await purchase_orders.getPlant({
            transaction
        });
        
        
        output.attachments = await purchase_orders.getAttachments({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.suppliers,
        as: 'supplier',
        
        where: filter.supplier ? {
          [Op.or]: [
            { id: { [Op.in]: filter.supplier.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.supplier.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.plants,
        as: 'plant',
        
        where: filter.plant ? {
          [Op.or]: [
            { id: { [Op.in]: filter.plant.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.plant.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



      {
        model: db.file,
        as: 'attachments',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.po_number) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'purchase_orders',
                        'po_number',
                        filter.po_number,
                    ),
                };
            }
            
            if (filter.currency) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'purchase_orders',
                        'currency',
                        filter.currency,
                    ),
                };
            }
            
            if (filter.notes) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'purchase_orders',
                        'notes',
                        filter.notes,
                    ),
                };
            }
            

            
            

            
            if (filter.order_dateRange) {
                const [start, end] = filter.order_dateRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    order_date: {
                    ...where.order_date,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    order_date: {
                    ...where.order_date,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.expected_delivery_atRange) {
                const [start, end] = filter.expected_delivery_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    expected_delivery_at: {
                    ...where.expected_delivery_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    expected_delivery_at: {
                    ...where.expected_delivery_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.total_amountRange) {
                const [start, end] = filter.total_amountRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    total_amount: {
                    ...where.total_amount,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    total_amount: {
                    ...where.total_amount,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            


      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.purchase_orders.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'purchase_orders',
                        'po_number',
                        query,
                    ),
                ],
            };
        }

        const records = await db.purchase_orders.findAll({
            attributes: [ 'id', 'po_number' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['po_number', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.po_number,
        }));
    }

    
};

